<p align="center"><img width="150" alt="CSS LSD Logo" src="./ressources/logo.svg"></p>
<p align="center">CssLsd is a Chromium Extension which allows for interactively modifying
the style of web pages using MIDI messages, Keyboard presses or Audio input
features.
.</p>

## Table of contents

- [Table of contents](#table-of-contents)
- [Setup](#setup)
- [Usage](#usage)
  - [User Interface](#user-interface)
    - [Open extension](#open-extension)
      - [Popup](#popup)
      - [Devtool & deported devtool](#devtool--deported-devtool)
    - [Start to use functionnalities](#start-to-use-functionnalities)
      - [Audio](#audio)
      - [MIDI](#midi)
      - [Loops](#loops)
    - [Upload and download](#upload-and-download)
  - [CSSLSD Code](#csslsd-code)
  - [MIDI Variables](#midi-variables)
  - [Audio Variables](#audio-variables)
  - [Types](#types)
  - [Options](#options)
  - [Examples](#examples)
- [Ressources](#ressources)

## Setup

- Download or Clone CssLsd
- Start Chromium
- Type chrome://extensions in the address bar
- Click "Load unpacked extension" and select the csslsd folder
- Now the extension should appear in the menu bar

## Usage

### User Interface

#### Open extension

##### Popup

![Popup view](doc/popup.png)
Pin the extension to get it close to URL bar. CLick on CSSLSD logo to open it.

##### Devtool & deported devtool

![Devtool view](doc/devtool.gif)
Open devtool, in "element", "source", "console" bar click on view more arrow, then drag-and-drop "CSSLSD" button.
You can put "element" tab to bottom by right-clicking on it.
For deported devtool, click on more (top-right) and then click on separate devtool dock.

#### Start to use functionnalities

##### Audio

![Devtool view](doc/activate_audio.gif)

Click on activate button, right top. When it becomes green you can click on audio one. If audio well started it's become green too. Don't forget to authorize the tab to get access to your microphone.

##### MIDI

Click on activate button, then on MIDI button. If this one becomes green, the MIDI is operationnal to use. Your device is displayed on top left. On control change on your MIDI device and if the extension pop-up is open the control ID will be displayed on top center. And if you focus text MIDI column parameter, control will be add to the list.

##### Loops

When you press record all interactions with the midi device are recorded in a table. When finished recording, press stop. You can then play your loop by pressing play or re-record over the previously created loop. Finally, you can overwrite the created magnifying glass. You have 4 slots available to save your loops. You can also map MIDI events to the actions listed above.

#### Upload and download

You have the possibility to export all CSS-LSD settings and codes as a JSON file. You can then import a previously exported JSON file from the extension. This can be useful for saving presets according to websites.

### CSSLSD Code

You need to use a custom CSS template, like below to map your audio or MIDI events to some CSSLSD properties. All parameters are between square brackets you can extend parameter by heritage with a range (this is not mandatory).

Code example:

```css
body {
    background-color:[couleur #000:#fff];
}
h1 {
    opacity: [opacité];
}
```

Parameters example:

<p align="center">
<img width="600" alt="Settings" src="./doc/settings.png">
</p>

To ***save*** your template, it's automatic ! Just type, edit what you want. It will be saved.

### MIDI Variables

| Midi Event  | Parameter | Informations                                        |
|-------------|-----------|-----------------------------------------------------|
| note        | id        | Note on, use case : note:21                         |
| cc          | id        | Control change, use case : cc:10                    |
| pb          |           | Pitchbend, use case : pb                            |

### Audio Variables

| Audio Event | Parameter | Informations                                        |
|-------------|-----------|-----------------------------------------------------|
| low         |           | low energy, use case : low                          |
| lomi        |           | lomi energy, use case : lomi                        |
| low         |           | mid energy, use case : mid                          |
| mihi        |           | mihi energy, use case : mihi                        |
| hi          |           | High energy, use case : hi                          |
| loud        |           | Volume meter, use case : loud                       |
| onset       | note      | Note, use case : onset:A                            |
| attack      |           | Attack, use case : attack                           |

### Types

| Option      | Informations                                                    |
|-------------|-----------------------------------------------------------------|
| min:max     | Decimal or hexadecimal min and max splited by ":"               |
| A;B;C       | Array splited by ";"                                            |

### Options

| Option      | Informations                                                    |
|-------------|-----------------------------------------------------------------|
| r           | Random value between type object                                |
| i:1         | Incremental value between type object, increment can be negative|
| d           | Linear value between type object                                |

### Examples

![Devtool view](doc/parameter_opacity.gif)

This exemple show, how to duplicate parameter, to add "opacité" one. And then add it to CSSLSD code via auto-completition.

## Ressources

- Chrome extensions : <https://developer.chrome.com/docs/extensions/mv3/getstarted/>
- ACE.js : <https://ace.c9.io/>
- WebMIDI : <https://webmidijs.org/>
- CSSParser : <http://glazman.org/JSCSSP/index.html>
